#include	<windows.h>
#include	<stdio.h>
#include	"x1.h"
#include	"x1_crtc.h"
#include	"x1_pcg.h"
#include	"x1_vram.h"
#include	"ddraws.h"
#include	"draw.h"
#include	"palettes.h"

		CRTC_TABLE	crtc;

		BYTE	crtc_TEXTPAL[8] = {
				0x00, 0x03, 0x0c, 0x0f, 0x30, 0x33, 0x3c, 0x3f};

		WORD	crtc_GRPHPAL[16] = {
				0x000, 0x008, 0x080, 0x088, 0x800, 0x808, 0x880, 0x888,
				0x000, 0x00f, 0x0f0, 0x0ff, 0xf00, 0xf0f, 0xff0, 0xfff};

static	BYTE	def_TEXTPAL[8] = {
				0x00, 0x03, 0x0c, 0x0f, 0x30, 0x33, 0x3c, 0x3f};
static	WORD	def_GRPHPAL[8] = {
				0x000, 0x00f, 0x0f0, 0x0ff, 0xf00, 0xf0f, 0xff0, 0xfff};


const	CRTC_TABLE	crtcdefault = {
				0xaa,						// PAL_B;
				0xcc,						// PAL_R;
				0xf0,						// PAL_G;
				0x00,						// PLY
				{0, 1, 2, 3, 4, 5, 6, 7},	// TEXT_PAL[8]
				0,							// SCRN_BITS
				0,							// CRTC_NUM

				0,							// DISP_PAGE
				8,							// FNT_XL
				8,							// FNT_YL
				40,							// TXT_XL
				25,							// TXT_YL
				28,							// TXT_YS
				320,						// GRP_XL
				200,						// GRP_YL
				0,							// CPU_BANK
				0,							// CRT_BANK

				200,						// CRT_YL
				232,						// CRT_VS
				266,						// CRT_VL

				31,							// TXT_VL
				10,							// TXT_VLA

				0,							// TXT_TOP
				8,							// fnty

				0,							// BLACKPAL
				0,							// EXTPALMODE
				0,							// EXTGRPHPAL
				0,							// lastgrphpal
	};

void crtc_updt(void);


/***********************************************************************
	
***********************************************************************/

void init_crtc(void) {

	crtc = crtcdefault;

	palandply = 1;

	if (x1flg.ROM_TYPE < 3) {
		memcpy(crtc_TEXTPAL, def_TEXTPAL, 8);
		memcpy(&crtc_GRPHPAL[8], def_GRPHPAL, 16);
	}
	if ((x1flg.ROM_TYPE >= 2) && (!(x1flg.DIP_SW & 1))) {
		crtc.SCRN_BITS = SCRN_200LINE;
		crtc.FNT_YL = 16;
	}

	textdrawproc_renewal();
	reflesh_palette();
	crtc_updt();

	vrambank_patch(0);
	palandply = 1;
	scrnallflash = 1;
}



void crtc_updt(void) {

	if (crtc.SCRN_BITS & SCRN_24KHZ) {
		crtc.fnty = (crtc.FNT_YL >> 1) & 0xfffe;
	}
	else {
		crtc.fnty = crtc.FNT_YL  & 0xfffe;
	}
	crtc.CRT_YL = crtc.fnty * crtc.TXT_YL;
	crtc.CRT_VS = crtc.fnty * (crtc.TXT_YS + 1);
	crtc.CRT_VL = (crtc.TXT_VL + 1) * crtc.fnty + crtc.TXT_VLA;
}


/***********************************************************************
	CRTC
***********************************************************************/

X1_IOW x1_crtc_w(WORD port, BYTE value) {

	if (port == 0x1800) {
		crtc.CRTC_NUM = value;
	}
	else if (port == 0x1801) {
		switch(crtc.CRTC_NUM) {
			case  1:
				if (value <= 40) {
					crtc.TXT_XL = 40;
				}
				else {
					crtc.TXT_XL = 80;
				}
				break;
			case  4:
				crtc.TXT_VL = value;
				break;
			case  5:
				crtc.TXT_VLA = value;
				break;
			case  6:
				crtc.TXT_YL = value;
				break;
			case  7:
				crtc.TXT_YS = value;
				break;
			case  9:
				crtc.FNT_YL = (WORD)value+1;
				break;
			case 12:
				*(((BYTE *)&crtc.TXT_TOP)+1) = (BYTE)(value & 7);
				doubleatrchange = 1;
				break;
			case 13:
				*(BYTE *)&crtc.TXT_TOP = value;
				doubleatrchange = 1;
				break;
			default:
				return;
		}
		crtc.GRP_XL = crtc.TXT_XL << 3;
		crtc.GRP_YL = 200;
		crtc_updt();
		scrnallflash = 1;								/* 990220 puni */
	}
}

/***********************************************************************
	PALLET
***********************************************************************/

X1_IOW x1_extpal_w(WORD port, BYTE value) {

	crtc.EXTPALMODE = value;
	palandply = 1;
}

X1_IOR x1_extpal_r(WORD port) {

	return(crtc.EXTPALMODE);
}

X1_IOW x1_extgrphpal_w(WORD port, BYTE value) {

	crtc.EXTGRPHPAL = value;
}

X1_IOR x1_extgrphpal_r(WORD port) {

	return(crtc.EXTGRPHPAL);
}

X1_IOW x1_exttextpal_w(WORD port, BYTE value) {

	if (crtc.EXTPALMODE & 0x80) {
		crtc_TEXTPAL[port-0x1fb8] = value;
		textpalette1(port-0x1fb8);
	}
}

X1_IOR x1_exttextpal_r(WORD port) {

	if (crtc.EXTPALMODE & 0x80) {
		return(crtc_TEXTPAL[port-0x1fb8]);
	}
	return(-1);
}



X1_IOW x1_palet_w(WORD port, BYTE value) {

	if (crtc.EXTPALMODE & 0x80) {
		crtc.lastgrphpal = 0;
		if (port & 0x80) {
			crtc.lastgrphpal |= 4;
		}
		if (port & 0x08) {
			crtc.lastgrphpal |= 2;
		}
		if (value & 0x80) {
			crtc.lastgrphpal |= 1;
		}
		if ((port & 0x44) || (value & 0x40)) {
			crtc.lastgrphpal |= 8;
		}
		else if (!(crtc.EXTGRPHPAL & 0x80)) {
			return;
		}
		if (crtc.EXTGRPHPAL & 8) {
			return;
		}
		value &= 0xf;
		switch(port & 0xff00) {
			case 0x1000:
				crtc_GRPHPAL[crtc.lastgrphpal] &= 0xff0;
				crtc_GRPHPAL[crtc.lastgrphpal] |= value;
				break;
			case 0x1100:
				crtc_GRPHPAL[crtc.lastgrphpal] &= 0xf0f;
				crtc_GRPHPAL[crtc.lastgrphpal] |= (value << 4);
				break;
			case 0x1200:
				crtc_GRPHPAL[crtc.lastgrphpal] &= 0x0ff;
				crtc_GRPHPAL[crtc.lastgrphpal] |= ((WORD)value << 8);
				break;
		}
		grphpalette1(crtc.lastgrphpal);
	}
	else {
		switch(port & 0xff00) {
			case 0x1000:
				if (crtc.PAL_B != value) {
					crtc.PAL_B = value;
					palandply = 1;
				}
				break;
			case 0x1100:
				if (crtc.PAL_R != value) {
					crtc.PAL_R = value;
					palandply = 1;
				}
				break;
			case 0x1200:
				if (crtc.PAL_G != value) {
					crtc.PAL_G = value;
					palandply = 1;
				}
				break;
		}
	}
}


X1_IOW x1_blackctrl_w(WORD port, BYTE value) {

	crtc.BLACKPAL = value;
	palandply = 1;
}

X1_IOR x1_blackctrl_r(WORD port) {

	return(crtc.BLACKPAL);
}


/***********************************************************************
	ײè
***********************************************************************/

X1_IOW x1_ply_w(WORD port, BYTE value) {

	if (crtc.PLY != value) {
		crtc.PLY = value;
		palandply = 1;
	}
}

X1_IOR x1_ply_r(WORD port) {

	return(crtc.PLY);
}


/***********************************************************************
	 
***********************************************************************/

X1_IOW x1_scrn_w(WORD port, BYTE value) {

	BYTE	scrnbitsbak = crtc.SCRN_BITS;

	crtc.SCRN_BITS = value;
	if ((crtc.SCRN_BITS ^ scrnbitsbak) & SCRN_DISPCHANGE) {
		textdrawproc_renewal();
		reflesh_palette();
		scrnallflash = 1;
		palandply = 1;
		crtc_updt();
	}
	vrambank_patch(value);
	crtc.CPU_BANK = (BYTE)((crtc.SCRN_BITS & SCRN_ACCESSVRAM)?1:0);
	crtc.CRT_BANK = (BYTE)((crtc.SCRN_BITS & SCRN_DISPVRAM)?1:0);
}

X1_IOR x1_scrn_r(WORD port) {

	return(crtc.SCRN_BITS);
}

